<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_Teachers extends Controller_Handler
{
        public function before() {
            parent::before();

            $this->user->checkAccess(User::RIGHTS_ADMIN);
        }

        protected function action_createTeacher() {
            $teacher = Model_Teacher::make()
                ->jobPosition($_POST['jobPositionID'])
                ->department($_POST['departmentID'])
                ->firstName($_POST['firstName'])
                ->secondName($_POST['secondName'])
                ->lastName($_POST['lastName'])
                ->create();

            $request = ['ID' => $teacher->ID, 'Code' => $teacher->ActivationCode];
            $this->request->body(json_encode($request));
        }

        public function action_search() {
            $facultyID = $this->post['FacultyID'] ? $this->post['FacultyID'] : $this->user->Faculty->ID;
            $departmentID = $this->post['DepartmentID'];
            $name = $this->post['Name'];

            $list = [];

            # dangerous block, don't try to understand
            if (strlen($this->post['Name']) >= 3) {
                $p = preg_split('/\s+/', $name) + ['', '', ''];
                array_multisort(array_map('strlen', $p), $p);
                $p = array_reverse($p);

                $list = Model_Teachers::search($p, $facultyID, $departmentID);
            }

            $this->response->body(json_encode($list));
        }
}
